/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("jazz.util.error");

dojo.require("dojo.i18n");
dojo.require("dojo.string");

dojo.requireLocalization("jazz.util", "errorMessages");

/*
 * PROVISIONAL: This API is considered provisional and may be changed or removed in the
 * future with minimal or no warning.
 * 
 * @since 0.7
 */
(function () {
jazz.util.error = {
	/*
	 * 	dfd - The dojo.Deferred object returned by the xhr request
	 * 
	 *  returns the default translated error message for an xhr response
	 */
	getDefaultXhrErrMsg: function (dfd /* dojo.Deferred */) {
		if (dfd.results) {
			for (var i = 0; i < dfd.results.length; i++) {
				if (dfd.results[i] && dfd.results[i].responseText && 
						dfd.results[i].responseText.indexOf("oauth_problem=timestamp_refused") !== -1) {
					return dojo.string.substitute(_messages.oauthTimestampErr, [dfd.ioArgs.url]);
				}
			}
		}
		return dojo.string.substitute(_messages.defaultXhrErr, [ dfd.ioArgs.url, dfd.ioArgs.xhr.status ]);
	}
};
})();

//
// Internal; do not call or reference
//

var _messages = dojo.i18n.getLocalization("jazz.util", "errorMessages");