/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
(function() {
dojo.provide("net.jazz.ajax.service.ui.mapping.GlobalNav");

dojo.require("dojo.cookie");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("net.jazz.ajax.service.ui.internal.login.LoginLogoutArea");
dojo.require("net.jazz.ajax.service.ui.userdata.FavoriteWidget");

var COOKIE_USER_ID = "net-jazz-ajax-cookie-userName";
var EVENT_LOGIN = "net.jazz.ajax.events.login";
var EVENT_LOGOUT = "net.jazz.ajax.events.logout";
var HOME_LINK = "/bogus/1";
var NEW_LINK = "/bogus/2";
var FAVORITES_LINK = "/_ajax-modules/net.jazz.ajax.GlobalNav/net.jazz.ajax.ManageFavorites";
var SEARCHES_LINK = "/bogus/4";
var HISTORY_LINK = "/_ajax-modules/net.jazz.ajax.GlobalNav/net.jazz.ajax.ManageHistory";
var EVENTS_LINK = "/bogus/6";

function getLoggedInUser() {
	return dojo.cookie(COOKIE_USER_ID);
}

dojo.declare("net.jazz.ajax.service.ui.mapping.GlobalNav", [dijit._Widget, dijit._Templated], {
	templateString: "<div class=\"net-jazz-ajax-globalNav\">" +
						"<div class=\"net-jazz-ajax-globalNav-wrapper\">" +
							"<div id=\"com-ibm-team-foundation-web-globalnav-favoriteWidget\" style=\"display:inline\"></div>" +
							"<ul id=\"com-ibm-team-foundation-web-globalnav\">" +
			    				"<li id=\"com-ibm-team-foundation-web-globalnav-myhome\"><a href=\"" + HOME_LINK + "\">My Home</a></li>" +
			    				"<li id=\"com-ibm-team-foundation-web-globalnav-new\"><a href=\"" + NEW_LINK + "\">New</a></li>" +
			    				"<li id=\"com-ibm-team-foundation-web-globalnav-favorites\"><a href=\"" + FAVORITES_LINK + "\">Favorites</a></li>" +
			    				"<li id=\"com-ibm-team-foundation-web-globalnav-searches\"><a href=\"" + SEARCHES_LINK + "\">Searches</a></li>" +
			    				"<li id=\"com-ibm-team-foundation-web-globalnav-history\"><a href=\"" + HISTORY_LINK + "\">History</a></li>" +
			    				"<li id=\"com-ibm-team-foundation-web-globalnav-events\"><a href=\"" + EVENTS_LINK + "\">Events</a></li>" +
								"<li id=\"com-ibm-team-foundation-web-globalnav-loginArea\"></li>" +
							"</ul>"+
						"</div>" + 
						"<div dojoAttachPoint=\"globalNavWidget\"></div>" +
	                "</div>",
	
	postCreate: function() {
		new net.jazz.ajax.service.ui.internal.login.LoginLogoutArea(
				null,
				dojo.byId("com-ibm-team-foundation-web-globalnav-loginArea"));
		new net.jazz.ajax.service.ui.userdata.FavoriteWidget({
			url: window.location.pathname
		}, dojo.byId("com-ibm-team-foundation-web-globalnav-favoriteWidget"));
		if (net.jazz.ajax.service._globalNavWidget != null) {
			var constructor = dojo.getObject(net.jazz.ajax.service._globalNavWidget);
			new constructor({id: net.jazz.ajax.service._globalNavWidget}, this.globalNavWidget);
		}
	}
});
})();